--	Target frame
function whoaTargetFrames (self, forceNormalTexture)
	local classification = UnitClassification(self.unit);
	self.highLevelTexture:SetPoint("CENTER", self.levelText, "CENTER", 0,0);
	self.deadText:SetPoint("CENTER", self.healthbar, "CENTER",0,0);
	self.unconsciousText:SetPoint("CENTER", self.healthbar, "CENTER",0,0);
	self.nameBackground:Hide();
	self.threatIndicator:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Flash");
	self.name:SetPoint("LEFT", self, 15, 36);
	self.healthbar:SetSize(119, 18);
	self.healthbar:SetPoint("TOPLEFT", 5, -24);
	self.healthbar.LeftText:SetPoint("LEFT", self.healthbar, "LEFT", 5, 0);
	self.healthbar.TextString:SetPoint("CENTER", self.healthbar, "CENTER", 0, 0);
	self.manabar:SetPoint("TOPLEFT", 5, -45);
	self.manabar:SetSize(119, 18);
	self.manabar.LeftText:SetPoint("LEFT", self.manabar, "LEFT", 5, 0);	
	self.manabar.RightText:ClearAllPoints();
	self.manabar.RightText:SetPoint("RIGHT", self.manabar, "RIGHT", -3, 0);
	self.manabar.TextString:SetPoint("CENTER", self.manabar, "CENTER", 0, 0);
	TargetFrame.threatNumericIndicator:SetPoint("BOTTOM", PlayerFrame, "TOP", 72, -21);
	FocusFrame.threatNumericIndicator:SetAlpha(0);
	if ( forceNormalTexture ) then
		self.borderTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame");
	elseif ( classification == "minus" ) then
		self.borderTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Minus");
		forceNormalTexture = true;
	elseif ( classification == "worldboss" or classification == "elite" ) then
		self.borderTexture:SetTexture("Interface\\Addons\\whoaUnitFrames\\media\\UI-TargetingFrame-Elite");
	elseif ( classification == "rareelite" ) then
		self.borderTexture:SetTexture("Interface\\Addons\\whoaUnitFrames\\media\\UI-TargetingFrame-Rare-Elite");
	elseif ( classification == "rare" ) then
		self.borderTexture:SetTexture("Interface\\Addons\\whoaUnitFrames\\media\\UI-TargetingFrame-Rare");
	else
		self.borderTexture:SetTexture("Interface\\Addons\\whoaUnitFrames\\media\\UI-TargetingFrame");
		forceNormalTexture = true;
	end
	if ( forceNormalTexture ) then
		self.haveElite = nil;
		if ( classification == "minus" ) then
			self.Background:SetSize(119,12);
			self.Background:SetPoint("BOTTOMLEFT", self, "BOTTOMLEFT", 7, 47);
			self.name:SetPoint("LEFT", self, 16, 19);
			self.healthbar:ClearAllPoints();
			self.healthbar:SetPoint("LEFT", 5, 3);
			self.healthbar:SetHeight(12);
			self.healthbar.LeftText:SetPoint("LEFT", self.healthbar, "LEFT", 3, 0);
			self.healthbar.RightText:SetPoint("RIGHT", self.healthbar, "RIGHT", -2, 0);
		else
			self.Background:SetSize(119,42);
			self.Background:SetPoint("BOTTOMLEFT", self, "BOTTOMLEFT", 7, 35);
		end
		if ( self.threatIndicator ) then
			if ( classification == "minus" ) then
				self.threatIndicator:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Minus-Flash");
				self.threatIndicator:SetTexCoord(0, 1, 0, 1);
				self.threatIndicator:SetWidth(256);
				self.threatIndicator:SetHeight(128);
				self.threatIndicator:SetPoint("TOPLEFT", self, "TOPLEFT", -24, 0);
			else
				self.threatIndicator:SetTexCoord(0, 0.9453125, 0, 0.181640625);
				self.threatIndicator:SetWidth(242);
				self.threatIndicator:SetHeight(93);
				self.threatIndicator:SetPoint("TOPLEFT", self, "TOPLEFT", -24, 0);
			end
		end
	else
		self.haveElite = true;
		self.Background:SetSize(119,42);
		if ( self.threatIndicator ) then
			self.threatIndicator:SetTexCoord(0, 0.9453125, 0.181640625, 0.400390625);
			self.threatIndicator:SetWidth(242);
			self.threatIndicator:SetHeight(112);
		end
	end
	if (self.questIcon) then
		if (UnitIsQuestBoss(self.unit)) then
			self.healthbar.RightText:SetPoint("RIGHT", self.healthbar, "RIGHT", -9, 0);
		else
			self.healthbar.RightText:SetPoint("RIGHT", self.healthbar, "RIGHT", -2, 0);
		end
	end
end
hooksecurefunc("TargetFrame_CheckClassification", whoaTargetFrames)

-- Mana texture
function whoaManaBar (manaBar)
	local powerType, powerToken, altR, altG, altB = UnitPowerType(manaBar.unit);
	local info = PowerBarColor[powerToken];
	if ( info ) then
		if ( not manaBar.lockColor ) then
			if not ( info.atlas ) and ( cfg.whoaTexture == true) then
				manaBar:SetStatusBarTexture(statubarsPath(self));
			end
		end
	end
end
hooksecurefunc("UnitFrameManaBar_UpdateType", whoaManaBar)

--	ToT & ToF
function whoaUnitTarget()
	TargetFrameToTTextureFrameDeadText:ClearAllPoints();
	TargetFrameToTTextureFrameDeadText:SetPoint("CENTER", "TargetFrameToTHealthBar","CENTER",1, 0);
	TargetFrameToTTextureFrameName:SetSize(65,10);
	TargetFrameToTTextureFrameTexture:SetTexture("Interface\\Addons\\"..whoaAddon.."\\media\\UI-TargetofTargetFrame");
	TargetFrameToTHealthBar:ClearAllPoints();
	TargetFrameToTHealthBar:SetPoint("TOPLEFT", 45, -15);
	TargetFrameToTHealthBar:SetHeight(10);
	TargetFrameToTManaBar:ClearAllPoints();
	TargetFrameToTManaBar:SetPoint("TOPLEFT", 45, -25);
	TargetFrameToTManaBar:SetHeight(5);
	FocusFrameToTTextureFrameDeadText:ClearAllPoints();
	FocusFrameToTTextureFrameDeadText:SetPoint("CENTER", "FocusFrameToTHealthBar" ,"CENTER",1, 0);
	FocusFrameToTTextureFrameName:SetSize(65,10);
	FocusFrameToTTextureFrameTexture:SetTexture("Interface\\Addons\\"..whoaAddon.."\\media\\UI-TargetofTargetFrame");
	FocusFrameToTHealthBar:ClearAllPoints();
	FocusFrameToTHealthBar:SetPoint("TOPLEFT", 43, -15);
	FocusFrameToTHealthBar:SetHeight(10);
	FocusFrameToTManaBar:ClearAllPoints();
	FocusFrameToTManaBar:SetPoint("TOPLEFT", 43, -25);
	FocusFrameToTManaBar:SetHeight(5);
end
-- hooksecurefunc("TargetFrame_CheckClassification", whoaFrameToTF)


--	Party Frames.
--	Boss target frames taints
local whoaPartyFrames = CreateFrame("Frame")
whoaPartyFrames:RegisterEvent("PLAYER_LOGIN")
whoaPartyFrames:RegisterEvent("PLAYER_ENTERING_WORLD")
whoaPartyFrames:SetScript('OnUpdate', function(self)
	local useCompact = GetCVarBool("useCompactPartyFrames");
	if (cfg.usePartyFrames) and (not useCompact) then
		for i = 1, 4 do
			if i then
				_G["PartyMemberFrame"..i.."HealthBar"]:SetStatusBarTexture(statubarsPath(self));
				_G["PartyMemberFrame"..i.."Name"]:SetSize(75,10);
				_G["PartyMemberFrame"..i.."Texture"]:SetTexture("Interface\\Addons\\"..whoaAddon.."\\media\\UI-PartyFrame");
				_G["PartyMemberFrame"..i.."Flash"]:SetTexture("Interface\\Addons\\"..whoaAddon.."\\media\\UI-PARTYFRAME-FLASH");
				_G["PartyMemberFrame"..i.."HealthBar"]:ClearAllPoints();
				_G["PartyMemberFrame"..i.."HealthBar"]:SetPoint("TOPLEFT", 46, -14); 
				_G["PartyMemberFrame"..i.."HealthBar"]:SetHeight(11);
				_G["PartyMemberFrame"..i.."ManaBar"]:ClearAllPoints();
				_G["PartyMemberFrame"..i.."ManaBar"]:SetPoint("TOPLEFT", 46, -27);
				_G["PartyMemberFrame"..i.."ManaBar"]:SetHeight(5);
				_G["PartyMemberFrame"..i.."HealthBarTextLeft"]:ClearAllPoints();
				_G["PartyMemberFrame"..i.."HealthBarTextLeft"]:SetPoint("LEFT", _G["PartyMemberFrame"..i.."HealthBar"], "LEFT", 75, 0.5);
				_G["PartyMemberFrame"..i.."HealthBarTextRight"]:ClearAllPoints();
				_G["PartyMemberFrame"..i.."HealthBarTextRight"]:SetPoint("CENTER", _G["PartyMemberFrame"..i.."HealthBar"], "CENTER", 0, 0.5);
				_G["PartyMemberFrame"..i.."ManaBarTextLeft"]:ClearAllPoints();
				_G["PartyMemberFrame"..i.."ManaBarTextLeft"]:SetPoint("LEFT", _G["PartyMemberFrame"..i.."ManaBar"], "LEFT", 60, 0);
				_G["PartyMemberFrame"..i.."ManaBarTextRight"]:ClearAllPoints();
				_G["PartyMemberFrame"..i.."ManaBarTextRight"]:SetPoint("RIGHT", _G["PartyMemberFrame"..i.."ManaBar"], "RIGHT", 0, 0);
				_G["PartyMemberFrame"..i.."HealthBarText"]:ClearAllPoints();
				_G["PartyMemberFrame"..i.."HealthBarText"]:SetPoint("CENTER", _G["PartyMemberFrame"..i.."HealthBar"], "CENTER", 0, 0);
				_G["PartyMemberFrame"..i.."ManaBarText"]:ClearAllPoints();
				_G["PartyMemberFrame"..i.."ManaBarText"]:SetPoint("CENTER", _G["PartyMemberFrame"..i.."ManaBar"], "CENTER", 0, 0.5);
				_G["PartyMemberFrame"..i.."ManaBarText"]:Hide();
				_G["PartyMemberFrame"..i.."ManaBarTextLeft"]:Hide();
				_G["PartyMemberFrame"..i.."ManaBarTextRight"]:Hide();
			end
		end
	end
end)

	--	Boss target frames
local whoaBossFrame = CreateFrame("Frame")
whoaBossFrame:RegisterEvent("PLAYER_LOGIN")
whoaBossFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
whoaBossFrame:SetScript('OnUpdate', function(self)
	if (cfg.useBossFrames) then
		for i = 1, MAX_BOSS_FRAMES do
			if i then
				_G["Boss"..i.."TargetFrameTextureFrameDeadText"]:ClearAllPoints();
				_G["Boss"..i.."TargetFrameTextureFrameDeadText"]:SetPoint("CENTER",_G["Boss"..i.."TargetFrameHealthBar"],"CENTER",0,0);
				_G["Boss"..i.."TargetFrameTextureFrameUnconsciousText"]:ClearAllPoints();
				_G["Boss"..i.."TargetFrameTextureFrameUnconsciousText"]:SetPoint("CENTER", _G["Boss"..i.."TargetFrameHealthBar"], "CENTER",0,0);
				_G["Boss"..i.."TargetFrameTextureFrameName"]:ClearAllPoints();
				_G["Boss"..i.."TargetFrameTextureFrameName"]:SetPoint("CENTER",_G["Boss"..i.."TargetFrame"],"CENTER",-57,-23);
				_G["Boss"..i.."TargetFrameTextureFrameTexture"]:SetTexture("Interface\\Addons\\whoaUnitFrames\\media\\UI-UNITFRAME-BOSS");
				_G["Boss"..i.."TargetFrameNameBackground"]:SetAlpha(0);
				_G["Boss"..i.."TargetFrameHealthBar"]:SetSize(116,20);
				_G["Boss"..i.."TargetFrameHealthBar"]:ClearAllPoints();
				_G["Boss"..i.."TargetFrameHealthBar"]:SetPoint("CENTER",_G["Boss"..i.."TargetFrame"],"CENTER",-51,18);
				_G["Boss"..i.."TargetFrameManaBar"]:SetSize(116,18);
				_G["Boss"..i.."TargetFrameManaBar"]:ClearAllPoints();
				_G["Boss"..i.."TargetFrameManaBar"]:SetPoint("CENTER",_G["Boss"..i.."TargetFrame"],"CENTER",-51,-3);
				_G["Boss"..i.."TargetFrameTextureFrameHealthBarTextLeft"]:ClearAllPoints();
				_G["Boss"..i.."TargetFrameTextureFrameHealthBarTextLeft"]:SetPoint("LEFT",_G["Boss"..i.."TargetFrameHealthBar"],"LEFT",0,0);
				_G["Boss"..i.."TargetFrameTextureFrameHealthBarTextRight"]:ClearAllPoints();
				_G["Boss"..i.."TargetFrameTextureFrameHealthBarTextRight"]:SetPoint("RIGHT",_G["Boss"..i.."TargetFrameHealthBar"],"RIGHT",0,0);
				_G["Boss"..i.."TargetFrameTextureFrameHealthBarText"]:ClearAllPoints();
				_G["Boss"..i.."TargetFrameTextureFrameHealthBarText"]:SetPoint("CENTER",_G["Boss"..i.."TargetFrameHealthBar"],"CENTER",0,0);
				_G["Boss"..i.."TargetFrameTextureFrameManaBarTextLeft"]:Hide();
				_G["Boss"..i.."TargetFrameTextureFrameManaBarTextLeft"]:SetPoint("LEFT",_G["Boss"..i.."TargetFrameManaBar"],"LEFT",0,0);
				_G["Boss"..i.."TargetFrameTextureFrameManaBarTextRight"]:Hide();
				_G["Boss"..i.."TargetFrameTextureFrameManaBarTextRight"]:SetPoint("RIGHT",_G["Boss"..i.."TargetFrameManaBar"],"RIGHT",0,0);
				_G["Boss"..i.."TargetFrameTextureFrameManaBarText"]:Hide();
				_G["Boss"..i.."TargetFrameTextureFrameManaBarText"]:SetPoint("CENTER",_G["Boss"..i.."TargetFrameManaBar"],"CENTER",0,0);
				_G["Boss"..i.."TargetFrameTextureFrameTexture"]:SetTexture("Interface\\Addons\\"..whoaAddon.."\\media\\UI-UNITFRAME-BOSS");
			end
		end
	end
end)